-- Chapitre 7 - Le quantificateur universel (voie annexe 7) --

openDB CLICOM.db;

write-b -- On complte les commandes 30179 et 30185 de manire  --;
write   -- ce qu'elles rfrencent tous les produits.            --;

insert into DETAIL values('30179','CS264',10);
insert into DETAIL values('30179','CS464',20);
insert into DETAIL values('30179','PA45',25);
insert into DETAIL values('30179','PH222',5);
insert into DETAIL values('30179','PS222',12);

insert into DETAIL values('30185','CS262',8);
insert into DETAIL values('30185','CS264',35);
insert into DETAIL values('30185','PA45',42);
insert into DETAIL values('30185','PH222',18);

write-ab -- On recherche ensuite les commandes qui rfrencent tous les produits. --;

select NCOM 
from   COMMANDE M
where  not exists (select *
                   from   PRODUIT P
                   where  P.NPRO not in (select NPRO
                                         from   DETAIL
                                         where  NCOM = M.NCOM));

select distinct NCOM 
from   DETAIL M
where  not exists (select *
                   from   PRODUIT P
                   where  P.NPRO not in (select NPRO
                                         from   DETAIL
                                         where  NCOM = M.NCOM));

select NCOM 
from   DETAIL
group by NCOM
having count(distinct NPRO) = (select count(*) from PRODUIT);

-- On restaure l'tat initial de la base de donnes --

abortDB;

closeDB;
